#!/usr/bin/env python3

"""
Child class of JournalFetcher
JCIM
"""

# import re
from input.get.journal_fetcher import JournalFetcher
from input.publication import Publication, Citation, Reference
import requests as req
from bs4 import BeautifulSoup as bs

class Fetcher(JournalFetcher):

    """
    """

    # TODO: Naming-Convention:
    #   Class: 'Fetcher'
    #   file: input_get_[journal-/organisation-name]
    #       format = "input_get_[a-z]*.py" allowed
    #   TODO: List of Compatable Journals
    _SUPPORTED_JOURNALS = []

    @staticmethod
    def can_use_url(url: str) -> bool:
        """
        Checks if given url links to a supported journal.
        """

        # TODO: Check the URL for compatability
        #   re.match in _SUPPORTED_JOURNALS
        return True 

    @staticmethod
    def get_publication(url: str) -> Publication:
        return input(url)
        

    @staticmethod
    def test_fetcher():
        pass

def get_article_info(soup):
    header = soup.find('div', class_ = 'article_header-left pull-left')
    article_title = header.find('span', class_ = 'hlFld-Title').text
    publication_date = header.find('span', class_ = 'pub-date-value').text
    for link in header.find('div', class_ = 'article_header-doiurl'):
        doi_url = link.get('href')
    subs = header.find('div', class_ = 'article_header-taxonomy')
    subjects = []
    for sub in subs.find_all('a'):
        subjects.append(sub.get('title'))
    cons = header.find('ul', class_ = 'loa')
    contributors = []
    for con in cons.find_all('span', class_ = 'hlFld-ContribAuthor'):
        contributors.append(con.text)
    numc = header.find('div', class_ = 'articleMetrics_count')
    if not numc.a:
        num_citations = 0
    else:
        num_citations = numc.a.text
    pub = Publication(doi_url, article_title, contributors, "JCIM",
                      publication_date, subjects, num_citations)
    #pub = Publication(article_title, publication_date, contributors, doi_url,
    #                  subjects, num_citations)
    return pub


def get_citation_info(pub, num_citations, soup):
    details = soup.find('ol', class_ = 'cited-content_cbyCitation')
    titles = [] 
    for title in details.find_all('span', 
            class_ = 'cited-content_cbyCitation_article-title'):
        titles.append(title.text.replace('.', ''))
    journal_names = []
    for name in details.find_all('span',
            class_ = 'cited-content_cbyCitation_journal-name'):
        journal_names.append(name.text)
    doi_urls = []
    for url in details.find_all('a'):
        doi_urls.append(url.get('href'))
    # TODO: There are a few diffrent types how Contributors are listed
    contributors = []
    for contrib in details.find_all('span', 
            class_ = 'cited-content_cbyCitation_article-contributors'):
        contributors.append(contrib.text)
    for i in range(0, int(num_citations)):
        pub.citations.append(Citation(doi_urls[i], titles[i], journal_names[i], \
                             contributors[i]))

def input(url):
    html_text = req.get(url).text
    soup = bs(html_text, 'html.parser')
    
    pub = get_article_info(soup)
    if int(pub.num_citations) > 0:
        get_citation_info(pub, int(pub.num_citations), soup)
    return pub
